#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>
#include <strings.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

extern int PipeRead;
extern int PipeWrite;
extern GtkWidget *text;
extern GtkWidget *DrawingArea;
extern GdkGC *gc;
extern GdkColor color_a;
extern GdkColor color_b;

extern int theId;

static GdkPixmap *pixmap = NULL;

void refreshAll();

int pressed = 0;
int px, py;


void refreshAll() {
    GdkRectangle update_rect;
    update_rect.x = 0;
    update_rect.y = 0;
    update_rect.width = DrawingArea->allocation.width;
    update_rect.height = DrawingArea->allocation.height;
    gtk_widget_draw (DrawingArea, &update_rect);
};

void on_TextLocal_insert_text (GtkEditable *editable, gchar *new_text, gint new_text_length, gint *position, gpointer user_data) {
  char buffer [40];
  int len;
  int index, reste;
  index = 0;
  
  reste = new_text_length;

  while (reste > 0) {
    strcpy (buffer, "C"); /* On envoie du texte */
    if (reste >= 18) len = 18;
    else len = reste;

    strncpy (&buffer[1], new_text + index, len);
    buffer [len+1] = '\0';

    /* On envoie tjs 20 caracteres : C + msg + \0 */
    if (PipeWrite != -1) write (PipeWrite, buffer, 20);
    else printf ("Erreur : descripteur = -1 \n");
    index = index + 18;
    reste = reste - len;
  }
}

void
on_ButtonClearDrawing_clicked          (GtkButton       *button,
                                        gpointer         user_data)
{
  char buffer [40];
   gdk_draw_rectangle (pixmap,
		       DrawingArea->style->white_gc,
		       TRUE,
		       0,
		       0,
		       DrawingArea->allocation.width, 
		       DrawingArea->allocation.height);
  
  refreshAll ();

  sprintf (buffer, "K");
  /* On envoie tjs 20 caracteres : C + msg + \0 */
  if (PipeWrite != -1) write (PipeWrite, buffer, 20);
  else printf ("Erreur : descripteur = -1 \n");
}
void on_ButtonClearRemote_clicked (GtkButton *button, gpointer user_data) {
  GtkWidget *widget;
  
  widget= lookup_widget (GTK_WIDGET (button), "TextRemote");
  gtk_text_freeze (GTK_TEXT (widget));
  gtk_editable_delete_text (GTK_EDITABLE (widget), 0, -1);
  gtk_text_thaw (GTK_TEXT (widget));
}


void on_ButtonClearLocal_clicked (GtkButton *button, gpointer user_data) {
  GtkWidget *widget;
  
  widget= lookup_widget (GTK_WIDGET (button), "TextLocal");
  gtk_text_freeze (GTK_TEXT (widget));
  gtk_editable_delete_text (GTK_EDITABLE (widget), 0, -1);
  gtk_text_thaw (GTK_TEXT (widget));
}

gint Listen (gpointer data) {
  unsigned char buffer[40]; /* Buffer reception */
  int i;
  buffer [0] = '\0';
	
  usleep (100);
  /* MAITRE */
  if (read (PipeRead, buffer, 20) <= 0) return 1;
    
  buffer [19] = '\0'; /* le 100eme */

  /* On quitte l'IHM si l'autre nous l'a demande */
  if (buffer [0] == 'Q') { 
    gtk_main_quit ();
  }

  if (buffer [0] == 'P') {
    int x, y;
    sscanf (&buffer[1], "%d %d", &x, &y);
    if (theId != 0) 
      gdk_gc_set_foreground (gc, &color_a); 
    else 
      gdk_gc_set_foreground (gc, &color_b); 

    gdk_draw_point (pixmap, gc, x, y);
    /* gdk_draw_point (DrawingArea->window, gc, x, y); */
    refreshAll();
  }
  else if (buffer [0] == 'M') {
    int x1, y1, x2, y2;
    sscanf (&buffer[1], "%d %d %d %d", &x1, &y1, &x2, &y2);
    if (theId != 0) 
      gdk_gc_set_foreground (gc, &color_a); 
    else 
      gdk_gc_set_foreground (gc, &color_b); 
    
    gdk_draw_line (pixmap, gc, x1, y1, x2, y2);
    refreshAll();
    /* gdk_draw_line (DrawingArea->window, gc, x1, y1, x2, y2); */
  }
  else if (buffer [0] == 'K') { 
    gdk_draw_rectangle (pixmap,
			DrawingArea->style->white_gc,
			TRUE,
			0,
			0,
			DrawingArea->allocation.width, 
			DrawingArea->allocation.height);
    refreshAll();
  }
  else {
    i = gtk_editable_get_position (GTK_EDITABLE (text));
    /* On filtre le caractere 'C' */
    gtk_editable_insert_text (GTK_EDITABLE (text), buffer+1, strlen (buffer) - 1, &i);
  }
  
  return 1; /* C'est un callback. Il faut retourner 1 !!! */
}

void on_Item_Quit (GtkMenuItem *menuitem, gpointer user_data) {
  char buffer [40];

  strcpy (buffer, "Q"); /* On informe l'autre IHM que l'on quitte */
  buffer [1] = '\0';
  buffer [19] = '\0';

  /* On informe l'autre IHM que l'on quitte */
  if (PipeWrite != -1) write (PipeWrite, buffer, 20);
  gtk_main_quit ();
}


gboolean on_MainWindow_quit (GtkWidget *widget, GdkEvent *event, gpointer user_data) {
  char buffer [40];

  strcpy (buffer, "Q"); /* On informe l'autre IHM que l'on quitte */
  buffer [1] = '\0';
  buffer [19] = '\0';

  /* On informe l'autre IHM que l'on quitte */
  if (PipeWrite != -1) write (PipeWrite, buffer, 20);
  gtk_main_quit ();
  return FALSE;
}


void on_ItemAbout_activate (GtkMenuItem *menuitem, gpointer user_data) {
  GtkWidget *dialog;
  GtkWidget *w;
  char buffer[100];

  dialog = create_DialogAbout ();
  w = lookup_widget (GTK_WIDGET (dialog), "LabelCompile");
  sprintf (buffer, "Release : %s %s", __DATE__, __TIME__);
  gtk_label_set_text (GTK_LABEL (w), buffer);
  gtk_widget_show (dialog);
}

void SendCaller () {
  char buffer [40];
  char *ptr;

  /* ptr = getenv ("DISPLAY"); */
  ptr = getenv ("LOGNAME");

  if (ptr) {  
    sprintf (buffer, "C%s (%s)", ptr, getenv ("DISPLAY")); 
    buffer [19] = '\0';
    if (PipeWrite != -1) write (PipeWrite, buffer, 20);

    sprintf (buffer, "C is speaking\n"); 
    buffer [19] = '\0';
    if (PipeWrite != -1) write (PipeWrite, buffer, 20);

  }
}

gboolean
on_DrawingArea_button_press_event      (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  char buffer [40];

  pressed = 1;
  px = event->x;
  py = event->y;
  
  if (theId == 0) 
    gdk_gc_set_foreground (gc, &color_a); 
  else 
    gdk_gc_set_foreground (gc, &color_b); 
  
  gdk_draw_point (pixmap, gc, event->x, event->y);
  /* gdk_draw_point (widget->window, gc, event->x, event->y); */
  refreshAll();
  
  sprintf (buffer, "P %d %d", px, py);
  /* On envoie tjs 20 caracteres : C + msg + \0 */
  if (PipeWrite != -1) write (PipeWrite, buffer, 20);
  else printf ("Erreur : descripteur = -1 \n");
  
  return FALSE;
}


gboolean
on_DrawingArea_motion_notify_event     (GtkWidget       *widget,
                                        GdkEventMotion  *event,
                                        gpointer         user_data)
{
  char buffer [40];
  if (pressed == 1) {
    if (theId == 0) 
      gdk_gc_set_foreground (gc, &color_a); 
    else 
      gdk_gc_set_foreground (gc, &color_b); 

    /* gdk_draw_line (widget->window, gc, px, py, event->x, event->y); */
    gdk_draw_line (pixmap, gc, px, py, event->x, event->y);
    refreshAll();

    sprintf (buffer, "M %d %d %d %d", (int) px, (int) py,(int) event->x, (int)event->y);
    /* On envoie tjs 20 caracteres : C + msg + \0 */
    if (PipeWrite != -1) write (PipeWrite, buffer, 20);
    else printf ("Erreur : descripteur = -1 \n");
  }

  px = event->x;
  py = event->y;

  return FALSE;
}


gboolean
on_DrawingArea_button_release_event    (GtkWidget       *widget,
                                        GdkEventButton  *event,
                                        gpointer         user_data)
{
  pressed = 0;
  return FALSE;
}

gboolean
on_DrawingArea_configure_event         (GtkWidget       *widget,
                                        GdkEventConfigure *event,
                                        gpointer         user_data)
{
  int i, j;
  GdkPixmap *tmp;
  unsigned char buffer [40];
  if (pixmap == 0) { /* First one */
    pixmap = gdk_pixmap_new(widget->window,
			    widget->allocation.width,
			    widget->allocation.height,
			    -1);
    
    gdk_draw_rectangle (pixmap,
			widget->style->white_gc,
			TRUE,
			0, 0,
			widget->allocation.width,
			widget->allocation.height);
  }
  else {
    /* new one */
    tmp = gdk_pixmap_new(widget->window,
			 widget->allocation.width,
			 widget->allocation.height,
			 -1);
    gdk_draw_rectangle (tmp,
			widget->style->white_gc,
			TRUE,
			0, 0,
			widget->allocation.width,
			widget->allocation.height);
    gdk_draw_pixmap(tmp,
		    widget->style->white_gc,
		    pixmap,
		    0, 0,
		    0, 0,
		    widget->allocation.width,
		    widget->allocation.height);
    
    gdk_pixmap_unref(pixmap);
    pixmap = tmp;
  }
  

  return TRUE;
}


gboolean
on_DrawingArea_expose_event            (GtkWidget       *widget,
                                        GdkEventExpose  *event,
                                        gpointer         user_data)
{
  gdk_draw_pixmap(widget->window,
		  gc,
		  pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);

  return FALSE;
}

